#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#define BACKLIGHT_PIN     3
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address

byte nC, m ;
void setup(){
  analogReference(EXTERNAL);  // setting required to use a precision band gap voltage reference (here 4.096V) for the ADC reference

  lcd.begin(20, 4);  // configure for 16 X 2 display

  // Switch on the backlight
  pinMode ( BACKLIGHT_PIN, OUTPUT );
  digitalWrite ( BACKLIGHT_PIN, HIGH );

  // Open serial communications and wait for port to open:
  Serial.begin(9600);
  Serial.setTimeout(30000);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  lcd.setCursor(1,1);    
  lcd.print("Hello N5IB!");
  delay(5000);
  lcd.home ();                   // go home
  lcd.print("Hello, ARDUINO ");  
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print (" Next line ");
  delay ( 1000 );
  lcd.clear();
  CustomChars();
}

void loop()
{


  Serial.print("enter character code (0 to 255 decimal: "); 
  while (Serial.available() > 0) Serial.read();   // clear the serial buffer
  byte TestChar = Serial.parseInt();
  Serial.print(TestChar,HEX); Serial.print(" , "); Serial.println(TestChar, DEC);
  lcd.clear();
  lcd.setCursor(0,0);  
  lcd.print("Test Code ");
  lcd.print(TestChar, HEX); 
  lcd.setCursor ( 7, 1 );        // go to the middle of the next line
  lcd.write(TestChar); lcd.write(TestChar+1); lcd.write(TestChar+2);
  delay(1000);
  lcd.clear();
  nC=0;
  BigNums(nC,0); delay(1000);
  BigNums(nC,1); delay(1000);
  BigNums(nC,2); delay(1000);
  BigNums(nC,3); delay(1000); 
  BigNums(nC,4); delay(1000);   
  BigNums(nC,10); delay(1000); 
}

void CustomChars() // creates a set of custom characters to be used to make large size displays
{
  byte tempChar[8];

  tempChar[0]=B00001;
  tempChar[1]=B00011;   
  tempChar[2]=B00111; 
  tempChar[3]=B01111;
  tempChar[4]=B11111;  
  tempChar[5]=B11111;
  tempChar[6]=B11111;
  tempChar[7]=B11111;
  lcd.createChar(0, tempChar);

  tempChar[0]=B11111;
  tempChar[1]=B11111;   
  tempChar[2]=B11111; 
  tempChar[3]=B11111;
  tempChar[4]=B01111;  
  tempChar[5]=B00111;
  tempChar[6]=B00011;
  tempChar[7]=B00001;
  lcd.createChar(1, tempChar);  

  tempChar[0]=B11111;
  tempChar[1]=B11111;   
  tempChar[2]=B11111; 
  tempChar[3]=B11111;
  tempChar[4]=B00000;  
  tempChar[5]=B00000;
  tempChar[6]=B00000;
  tempChar[7]=B00000;
  lcd.createChar(2, tempChar); 
  
  tempChar[0]=B00000;
  tempChar[1]=B00000;   
  tempChar[2]=B00000; 
  tempChar[3]=B00000;
  tempChar[4]=B11111;  
  tempChar[5]=B11111;
  tempChar[6]=B11111;
  tempChar[7]=B11111;
  lcd.createChar(3, tempChar);  
  
  tempChar[0]=B00000;
  tempChar[1]=B00000;   
  tempChar[2]=B00000; 
  tempChar[3]=B00000;
  tempChar[4]=B00000;  
  tempChar[5]=B00000;
  tempChar[6]=B11111;
  tempChar[7]=B11111;
  lcd.createChar(4, tempChar);  
  
  tempChar[0]=B11111;
  tempChar[1]=B11111;   
  tempChar[2]=B00000; 
  tempChar[3]=B00000;
  tempChar[4]=B00000;  
  tempChar[5]=B00000;
  tempChar[6]=B00000;
  tempChar[7]=B00000;
  lcd.createChar(5, tempChar);  

  tempChar[0]=B10000;
  tempChar[1]=B11000;   
  tempChar[2]=B11100; 
  tempChar[3]=B11110;
  tempChar[4]=B11111;  
  tempChar[5]=B11111;
  tempChar[6]=B11111;
  tempChar[7]=B11111;
  lcd.createChar(6, tempChar);
    
  tempChar[0]=B11111;
  tempChar[1]=B11111;   
  tempChar[2]=B11111; 
  tempChar[3]=B11111;
  tempChar[4]=B11110;  
  tempChar[5]=B11100;
  tempChar[6]=B11000;
  tempChar[7]=B10000;
  lcd.createChar(7, tempChar);  
}

void BigNums(byte nnC, byte mm)
{
   switch(mm) {
     case 0:
         lcd.setCursor(nC,0);
         lcd.write(8); lcd.write(2); lcd.write(6);  // "8" means the same as "0" here..... don't ask  %&$#*!
         lcd.setCursor(nnC,1);
         lcd.write(0xFF); lcd.write(0x20); lcd.write(0xFF);
         lcd.setCursor(nnC,2);
         lcd.write(0xFF); lcd.write(0x20); lcd.write(0xFF);
         lcd.setCursor(nnC,3);
         lcd.write(1); lcd.write(3); lcd.write(7);
         nC=nnC+4;
         break;
                        
     case 1:
         lcd.setCursor(nnC,0);  
         lcd.write(8);
         lcd.setCursor(nnC,1);
         lcd.write(0xFF);
         lcd.setCursor(nnC,2);
         lcd.write(0xFF);
         lcd.setCursor(nnC,3);
         lcd.write(0xFF);
         nC=nnC+2;
         break;

     case 2:
         lcd.setCursor(nnC,0);  
         lcd.write(2); lcd.write(2); lcd.write(0xFF);
         lcd.setCursor(nnC,1);
         lcd.write(0x20); lcd.write(3); lcd.write(2);
         lcd.setCursor(nnC,2);
         lcd.write(0xFF); lcd.write(0x20); lcd.write(0x20);
         lcd.setCursor(nnC,3);
         lcd.write(1); lcd.write(3); lcd.write(8);
         nC=nnC+4;     
         break;

     case 3:
         lcd.setCursor(nnC,0);  
         lcd.write(2); lcd.write(2); lcd.write(6);
         lcd.setCursor(nnC,1);
         lcd.write(0x20); lcd.write(4); lcd.write(0xFF);
         lcd.setCursor(nnC,2);
         lcd.write(0x20); lcd.write(5); lcd.write(0xFF);
         lcd.setCursor(nnC,3);
         lcd.write(3); lcd.write(3); lcd.write(7);
         nC=nnC+4;     
        break;

     case 4:
         lcd.setCursor(nnC,0);  
         lcd.write(8); lcd.write(0x20); lcd.write(0xFF);
         lcd.setCursor(nnC,1);
         lcd.write(0xFF); lcd.write(4); lcd.write(0xFF);
         lcd.setCursor(nnC,2);
         lcd.write(5); lcd.write(5); lcd.write(0xFF);
         lcd.setCursor(nnC,3);
         lcd.write(0x20); lcd.write(0x20); lcd.write(0xFF);
         nC=nnC+4;          
        break;

     case 5:
        break;

     case 6:
        break;

     case 7:
        break;

     case 8:
        break; 

     case 9:
        break;

     case 10:  // draws ":"
         lcd.setCursor(nnC,1);  
         lcd.write(2);
         lcd.setCursor(nnC,2);
         lcd.write(3);
         nC=nnC+2;     
        break;
                 
   }  
}

